<template>
  <el-container>
    <transition name="el-zoom-in-center">
      <el-main v-show="isShow">
        <el-row style="margin-bottom: 2%">
          <el-card shadow="hover">
            <el-row :gutter="20">
              <el-col :span="5">
                <!-- Направление продаж -->
                <ComponentSelectSellingDirection :event-bus="eventBus" />
              </el-col>
              <el-col :span="5">
                <!-- Целевая аудитория -->
                <BaseAudiencesComponent :event-bus="eventBus" />
              </el-col>
              <el-col :span="5">
                <!-- Канал -->
                <ComponentSelectChannel
                  :event-bus="eventBus"
                  :isMultiple="false"
                />
              </el-col>
              <el-col :span="5">
                <!-- Год и месяц -->
                <DateBaseChannelAudiencesComponent :event-bus="eventBus" />
              </el-col>
              <el-col :span="4">
                <!-- Добавления аудиторию в БД -->
                <AddBaseAudiencesChannelComponent :event-bus="eventBus" />
              </el-col>
            </el-row>
          </el-card>
        </el-row>
        <el-row>
          <el-card shadow="hover">
            <el-row style="margin-bottom: 2%">
              <!-- Поиск каналов в сохраненых целевых аудиториях -->
              <SearchChannelBaseAudiencesTableComponent :event-bus="eventBus" />
            </el-row>
            <el-row>
              <!-- Список сохраненых целевых аудиторий -->
              <TableBaseAudiencesChannelsComponent :event-bus="eventBus" />
            </el-row>
          </el-card>
        </el-row>
      </el-main>
    </transition>
  </el-container>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import BaseAudiencesComponent from "../components/save-update-TVR-view/BaseAudiencesComponent.vue";
import DateBaseChannelAudiencesComponent from "@/components/save-update-TVR-view/DateBaseChannelAudiencesComponent.vue";
import ComponentAddChannelBaseAudience from "@/components/save-update-TVR-view/AddBaseAudiencesChannelComponent.vue";
import TableBaseAudiencesChannelsComponent from "@/components/save-update-TVR-view/TableBaseAudiencesChannelsComponent.vue";
import SearchChannelBaseAudiencesTableComponent from "@/components/save-update-TVR-view/SearchChannelBaseAudiencesTableComponent.vue";
import ComponentSelectSellingDirection from "@/components/common/ComponentSelectSellingDirection.vue";
import ComponentSelectChannel from "@/components/common/ComponentSelectChannel.vue";

/**
 * Представление добавления базовой аудитории.
 */
@Component({
  components: {
    ComponentSelectChannel,
    ComponentSelectSellingDirection,
    BaseAudiencesComponent,
    DateBaseChannelAudiencesComponent,
    AddBaseAudiencesChannelComponent: ComponentAddChannelBaseAudience,
    TableBaseAudiencesChannelsComponent,
    SearchChannelBaseAudiencesTableComponent,
  },
})
export default class ViewChannelBaseAudience extends Vue {
  /**
   * Автобус событий.
   * Главная сущость представления и дочерних компонентов этого представления.
   * Является тунелем, по которому общаются и передают данные между собой дочерние компоненты и представление.
   */
  private eventBus: Vue = new Vue();

  /**
   * @property {boolean} isShow - признак "отображать элемент".
   */
  private isShow = false;

  /**
   * Метод срабатывает после инициализации представления.
   */
  protected mounted(): void {
    // Отображаем элементы представления после небольшой задержки, чтобы
    // воспроизвелась анимация
    setTimeout(() => (this.isShow = true), 200);
  }
}
</script>

<style></style>
